diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/BlockSaplingBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
index 37e9ef662..0b0652607 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
@@ -63,7 +63,7 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
         if(!world.isClientSide)
         {
-            ((BlockSaplingBase)Block.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
+            ((BlockSaplingBase)Blocks.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockSign.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/BlockSign.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockSign.java
index e703f2a4c..02db3af0a 100644
--- a/src/main/java/net/minecraft/core/block/BlockSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockSign.java
@@ -33,18 +33,11 @@ public class BlockSign extends BlockTileEntity
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.getSelectedBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         if(isFreeStanding)
         {
-            return;
+            return getBounds();
         }
         int l = world.getBlockMetadata(x, y, z);
         float f = 0.28125F;
@@ -75,22 +68,17 @@ public class BlockSign extends BlockTileEntity
         {
             setBlockBounds(-0.375F, f, f2, f4, f1, f3);
         }*/
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        if(l == 2)
-        {
-            setBlockBounds(f2, f, 1.0F - f4, f3, f1, 1.0F);
-        }
-        if(l == 3)
-        {
-            setBlockBounds(f2, f, 0.0F, f3, f1, f4);
-        }
-        if(l == 4)
-        {
-            setBlockBounds(1.0F - f4, f, f2, 1.0F, f1, f3);
-        }
-        if(l == 5)
-        {
-            setBlockBounds(0.0F, f, f2, f4, f1, f3);
+        switch (l) {
+            case 2:
+                return AABB.getTemporaryBB(f2, f, 1.0F - f4, f3, f1, 1.0F);
+            case 3:
+                return AABB.getTemporaryBB(f2, f, 0.0F, f3, f1, f4);
+            case 4:
+                return AABB.getTemporaryBB(1.0F - f4, f, f2, 1.0F, f1, f3);
+            case 5:
+                return AABB.getTemporaryBB(0.0F, f, f2, f4, f1, f3);
+            default:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockSlab.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/BlockSlab.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockSlab.java
index 9bce7fba7..84bfed3e5 100644
--- a/src/main/java/net/minecraft/core/block/BlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockSlab.java
@@ -34,32 +34,25 @@ public class BlockSlab extends Block
         this.modelBlockMetadata = modelBlockMetadata;
         withHardness(modelBlock.blockHardness);
         withBlastResistance(modelBlock.blastResistance / 3F);
-        withLightEmission(lightEmission[modelBlock.id]);
+        withLightEmission(Blocks.lightEmission[modelBlock.id]);
         withLightBlock(1);
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z) & 0x3;
-        if(l == 0)
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
-        else if(l==1)
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        else if(l==2)
-            setBlockBounds(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+        switch (l) {
+            case 0:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
+            case 1:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case 2:
+            default:
+                return AABB.getTemporaryBB(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+        }
     }
 
-    @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        int l = world.getBlockMetadata(x, y, z) & 0x3;
-        if(l == 0)
-            return AABB.getTemporaryBB(x, y, z, x +1f, y +0.5f, z +1f);
-        if(l == 1)
-            return AABB.getTemporaryBB(x, y, z, x +1, y +1f, z +1f);
-        return AABB.getTemporaryBB(x, y +0.5f, z, x +1f, y +1f, z +1f);
-    }
 
     @Override
 	public boolean isSolidRender()
@@ -131,13 +124,6 @@ public class BlockSlab extends Block
         return modelBlock.tickDelay();
     }
 
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
-
     @Override
     public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
@@ -211,12 +197,6 @@ public class BlockSlab extends Block
         modelBlock.onBlockPlacedByWorld(world, x, y, z);
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return modelBlock.getRenderLayer();
-    }
-
     @Override
     public float getBlastResistance(Entity entity)
     {
diff --git a/src/main/java/net/minecraft/core/block/BlockStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockStairs.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BlockStairs.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockStairs.java
index f132a8296..d2c46316f 100644
--- a/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockStairs.java
@@ -90,18 +90,6 @@ public class BlockStairs extends Block
         withLightBlock(255);
     }
 
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-    }
-
-    @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return super.getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
     @Override
 	public boolean isSolidRender()
     {
@@ -120,7 +108,7 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList aabbList)
+    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
     {
         int meta = world.getBlockMetadata(x, y, z);
         int hRotation = meta & 0b0011;
@@ -128,33 +116,24 @@ public class BlockStairs extends Block
 
         float stepYOffset = vRotation > 0 ? 0.5f : 0.0f;
 
-        if(hRotation == 0)
-        {
-            setBlockBounds(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-        } else
-        if(hRotation == 1)
-        {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-        } else
-        if(hRotation == 2)
-        {
-            setBlockBounds(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-        } else {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
+        switch (hRotation) {
+            case 0:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                break;
+            case 1:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                break;
+            case 2:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                break;
+            default:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                break;
         }
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
     }
 
     @Override
@@ -221,24 +200,12 @@ public class BlockStairs extends Block
         return modelBlock.getBlastResistance(entity);
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return modelBlock.getRenderLayer();
-    }
-
     @Override
     public int tickDelay()
     {
         return modelBlock.tickDelay();
     }
 
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return modelBlock.getSelectedBoundingBoxFromPool(world, x, y, z);
-    }
-
 //    @Override
 //    public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
 //    {
diff --git a/src/main/java/net/minecraft/core/block/BlockSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/BlockSugarcane.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java
index 29df647a7..55af54518 100644
--- a/src/main/java/net/minecraft/core/block/BlockSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java
@@ -65,11 +65,11 @@ public class BlockSugarcane extends Block implements IBonemealable
         {
             return true;
         }
-        if(Block.blocksList[l] == null)
+        if(Blocks.blocksList[l] == null)
         {
             return false;
         }
-        if (!Block.blocksList[l].hasTag(BlockTags.GROWS_SUGAR_CANE))
+        if (!Blocks.blocksList[l].hasTag(BlockTags.GROWS_SUGAR_CANE))
         {
             return false;
         }
@@ -137,7 +137,7 @@ public class BlockSugarcane extends Block implements IBonemealable
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
-            ((BlockSugarcane)Block.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
+            ((BlockSugarcane)Blocks.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockTNT.java b/game/core/src/main/java/net/minecraft/core/block/BlockTNT.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BlockTNT.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockTNT.java
index b06e9a886..9b5d0b718 100644
--- a/src/main/java/net/minecraft/core/block/BlockTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockTNT.java
@@ -26,7 +26,7 @@ public class BlockTNT extends Block {
 
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		if (blockId > 0 && Block.blocksList[blockId].isSignalSource() && world.hasNeighborSignal(x, y, z)) {
+		if (blockId > 0 && Blocks.blocksList[blockId].isSignalSource() && world.hasNeighborSignal(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockTallGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BlockTallGrass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java
index 8ea97d60a..4b74de667 100644
--- a/src/main/java/net/minecraft/core/block/BlockTallGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java
@@ -18,7 +18,7 @@ public class BlockTallGrass extends BlockFlower
 
     @Override
     protected boolean mayPlaceOn(int blockId) {
-    	Block block = Block.getBlock(blockId);
+    	Block block = Blocks.getBlock(blockId);
     	if(block instanceof BlockMoss) {
     		return true;
     	}
diff --git a/src/main/java/net/minecraft/core/block/BlockTileEntity.java b/game/core/src/main/java/net/minecraft/core/block/BlockTileEntity.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BlockTileEntity.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockTileEntity.java
index 2ef0bc440..ac2396e27 100644
--- a/src/main/java/net/minecraft/core/block/BlockTileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockTileEntity.java
@@ -11,7 +11,7 @@ public abstract class BlockTileEntity extends Block
 	public BlockTileEntity(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
-        isEntityTile[id] = true;
+        Blocks.isEntityTile[id] = true;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockTorch.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/BlockTorch.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockTorch.java
index b099736fc..35f06cfcf 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockTorch.java
@@ -36,6 +36,26 @@ public class BlockTorch extends Block
         return null;
     }
 
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
+        float f = 0.15F;
+        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (side) {
+            case SIDE_WEST:
+                return AABB.getTemporaryBB(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+            case SIDE_EAST:
+                return AABB.getTemporaryBB(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+            case SIDE_NORTH:
+                return AABB.getTemporaryBB(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+            case SIDE_SOUTH:
+                return AABB.getTemporaryBB(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+            case SIDE_BOTTOM:
+            default:
+                final float f1 = 0.1F;
+                return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+        }
+    }
+
     @Override
 	public boolean isSolidRender()
     {
@@ -275,32 +295,6 @@ public class BlockTorch extends Block
         }
     }
 
-    @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
-    {
-        float f = 0.15F;
-        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
-        switch (side) {
-            case SIDE_WEST:
-                setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
-                break;
-            case SIDE_EAST:
-                setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
-                break;
-            case SIDE_NORTH:
-                setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
-                break;
-            case SIDE_SOUTH:
-                setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
-                break;
-            case SIDE_BOTTOM:
-                final float f1 = 0.1F;
-                setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
-                break;
-        }
-        return super.collisionRayTrace(world, x, y, z, start, end);
-    }
-
     @Override
 	public void animationTick(World world, int x, int y, int z, Random rand)
     {
@@ -336,6 +330,6 @@ public class BlockTorch extends Block
     
     @Override
     public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getLightmapCoord(x, y, z, lightEmission[id] > 0 ? 15 : 0);
+		return blockAccess.getLightmapCoord(x, y, z, Blocks.lightEmission[id] > 0 ? 15 : 0);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BlockTrapDoor.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
index 95fdf7cff..ad1a1e9f0 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
@@ -58,40 +58,27 @@ public class BlockTrapDoor extends Block implements IPaintable {
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.getSelectedBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
         float thickness = 3/16f;
 
         if (isTrapdoorOpen(meta)) {
-            if ((meta & MASK_DIRECTION) == DIRECTION_SOUTH) { // South
-                setBlockBounds(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
-            }
-            if ((meta & MASK_DIRECTION) == DIRECTION_NORTH) { // North
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
-            }
-            if ((meta & MASK_DIRECTION) == DIRECTION_EAST) { // East
-                setBlockBounds(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            }
-            if ((meta & MASK_DIRECTION) == DIRECTION_WEST) { // West
-                setBlockBounds(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
+            switch (meta & MASK_DIRECTION) {
+                case DIRECTION_SOUTH:  // South
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
+                case DIRECTION_NORTH:  // North
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
+                case DIRECTION_EAST:  // East
+                    return AABB.getTemporaryBB(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                case DIRECTION_WEST:  // West
+                default:
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
             }
         } else {
             if (isUpperHalf(meta)) {
-                setBlockBounds(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
             } else {
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
             }
         }
     }
@@ -129,7 +116,7 @@ public class BlockTrapDoor extends Block implements IPaintable {
             return;
         }
 
-        Block block = Block.getBlock(blockId);
+        Block block = Blocks.getBlock(blockId);
         if (block == null || block.isSignalSource()) {
             int meta = world.getBlockMetadata(x, y, z);
             boolean isOpened = isTrapdoorOpen(meta);
@@ -142,12 +129,6 @@ public class BlockTrapDoor extends Block implements IPaintable {
         }
     }
 
-    @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end) {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.collisionRayTrace(world, x, y, z, start, end);
-    }
-
     @Override
     public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
         int meta = getMetaForDirection(player == null ? side.getDirection().getOpposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
diff --git a/src/main/java/net/minecraft/core/block/BlockWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
similarity index 99%
rename from src/main/java/net/minecraft/core/block/BlockWireRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
index d67503682..f53ec0923 100644
--- a/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
@@ -350,7 +350,7 @@ public class BlockWireRedstone extends Block {
         if (blockId <= 0) {
             return false;
         }
-        if (Block.blocksList[blockId].isSignalSource()) {
+        if (Blocks.blocksList[blockId].isSignalSource()) {
             return true;
         }
         if (blockId == Blocks.PUMPKIN_REDSTONE.id) {
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/Blocks.java
rename to game/core/src/main/java/net/minecraft/core/block/Blocks.java
index bcefa2819..961b5ae59 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -22,8 +22,27 @@ import net.minecraft.core.item.block.ItemBlockStairsPainted;
 import net.minecraft.core.item.block.ItemBlockLamp;
 import net.minecraft.core.item.block.ItemBlockSlabPainted;
 import net.minecraft.core.sound.BlockSounds;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.Map;
 
 public final class Blocks {
+    public static final @Nullable Block @NotNull [] blocksList = new Block[16384];
+    public static final Map<NamespaceID, Block> blockMap = new LinkedHashMap<>();
+    @Deprecated public static final Map<String, Integer> keyToIdMap = new HashMap<>();
+    public static final boolean[] shouldTick = new boolean[blocksList.length];
+    public static final boolean[] solid = new boolean[blocksList.length];
+    public static final boolean[] isEntityTile = new boolean[blocksList.length];
+    public static final int[] lightBlock = new int[blocksList.length];
+    public static final boolean[] translucent = new boolean[blocksList.length];
+    public static final int[] lightEmission = new int[blocksList.length];
+    public static final boolean[] neighborNotifyOnMetadataChangeDisabled = new boolean[blocksList.length];
+    public static int highestBlockId = 0;
+
     public static Block STONE;
     public static Block BASALT;
     public static Block LIMESTONE;
@@ -449,11 +468,11 @@ public final class Blocks {
         setupBlocks();
         BlockMoss.initMossMap();
 
-        for(int i = 0; i < Block.blocksList.length; i++)
+        for(int i = 0; i < blocksList.length; i++)
         {
-            if(Block.blocksList[i] != null)
+            Block block;
+            if((block = blocksList[i]) != null)
             {
-                Block block = Block.blocksList[i];
                 if (Item.itemsList[i] == null){
                     Item item = block.blockItemSupplier.get();
                     if (block.statParent != null){
@@ -465,11 +484,17 @@ public final class Blocks {
             }
         }
 
-        Block.translucent[0] = true;
+        translucent[0] = true;
 
         MaterialColor.assignManualEntries();
     }
 
+    @Nullable
+    public static Block getBlock(int id)
+    {
+        return Blocks.blocksList[Math.max(id, 0)];
+    }
+
     public static void setupBlocks(){
         STONE = new BlockStone("stone", "minecraft:block/stone", 1, () -> Blocks.COBBLE_STONE, Material.stone).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 46d19805d..7c317a9d4 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -11,7 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
@@ -204,7 +204,7 @@ public class TileEntityBasket extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index c5171fa06..74407bb7f 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -10,7 +10,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.UUIDHelper;
 import org.jetbrains.annotations.Nullable;
@@ -237,7 +237,7 @@ public class TileEntityFlag extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
similarity index 87%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index d5064de3d..cfc9e0f57 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -3,10 +3,11 @@ package net.minecraft.core.block.entity;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.world.World;
 
 public class TileEntityFlowerJar extends TileEntity {
@@ -35,7 +36,7 @@ public class TileEntityFlowerJar extends TileEntity {
         super.dropContents(world, x, y, z);
         if (flowerInPot > 0 && Block.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
             if (!world.isClientSide) {
-                if (Block.getBlock(flowerInPot) instanceof BlockFlowerStackable) {
+                if (Blocks.getBlock(flowerInPot) instanceof BlockFlowerStackable) {
                     world.dropItem(x, y, z, new ItemStack(flowerInPot, BlockFlowerStackable.getStackCount(flowerData) + 1, 0));
                 } else {
                     world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
@@ -47,7 +48,7 @@ public class TileEntityFlowerJar extends TileEntity {
 
     @Override
     public Packet getDescriptionPacket() {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 
 }
\ No newline at end of file
